#include<stdlib.h>
#include<stdio.h>
#include "macierz.h"

/* Funkcja tworzy macierz o podanej liczbie wierszy 'w' i kolumn 'k'.
 * Wartoscia zwracana jest adres (wskaznik) do tablicy o dlugosci 'w' zawierajacej adresy do tablic o dlugosci 'k' zawierajacych liczby rzeczywiste. */
float **utworz_macierz(int w, int k)
{
	float **M;
	int iw=0;
	M=(float **)malloc(w * sizeof(float *));
	if (M==NULL) return NULL;
	for (iw=0;iw<w;iw++)
	{
		*(M+iw)=(float *)malloc(k * sizeof(float));
		if(*(M+iw)==NULL)
	  	{
			zwolnij_macierz(M,iw);
			return NULL;
		}
	}
	return M;
}

/* Funkcja wyswietla elementy macierzy 'M' posiadajacej 'w' wierszy i 'k' kolumn.  */
void wyswietl_macierz(float **M, int w, int k)
{
	int iw=0,ik;
	printf("\nMacierz %dx%d\n",w,k);
	while(iw<w)
 	{
		ik=0;
  		while(ik<k)
  		{
 	  		printf("%6.2f",*(*(M+iw)+ik));
			ik++;
  		}
		iw++;
 		printf("\n");
	}
}

/* Funkcja zwalnia pamiec zajeta przez macierz 'm' posiadajacej 'w' wierszy. */
void zwolnij_macierz(float **M, int w)
{
	while(w>0)
	{
		free(*(M+w-1));
		w--;
	}
	free(M);
}

/* Funkcja wczytuje wartosci macierzy z ekranu. Macierz 'M' musi byc utworzona dynamicznie za pomoca funkcji 'utworz_macierz' i musi posiadac 'w' wierszy i 'k' kolumn.
   Wartoscia zwracana jest adres macierzy **M
   */
float ** wczytaj_macierz(float **M, int w, int k)
{
	int iw,ik;
 	printf("Podaj elementy macierzy %dx%d\n",w,k);
 	for(iw=0;iw<w;iw++)
 	{
  		for(ik=0;ik<k;ik++)
  		{
   		printf("[%d,%d] = ",iw+1,ik+1);
   		scanf("%f",*(M+iw)+ik);
  		}
 	}
	return M;
}

/* Funkcja zapisuje do pliku podana macierz.
 * Zmienna 'plik' musi byc wskaznikiem do pliku tekstowego otworzonego w trybie do zapisu.
 * Wskaznik 'M' musi zawierac adres do macierzy posiadajacej 'w' wierzy i 'k' kolumn.
 * Do pliku najpierw zapisywane sa wymiary macierzy (ilosc wierszy i kolumn) a nastepnie wszystkie elementy macierzy. */
void zapisz_macierz(FILE *plik,float **M,int w,int k)
{
	fprintf(plik,"%d %d\n",w,k);
	int iw,ik;
	for (iw=0;iw<w;iw++)
	{
		for (ik=0;ik<k;ik++)
			fprintf(plik,"%6.2f ",*(*(M+iw)+ik));
		fprintf(plik,"\n");
	}
}

/* Funkcja odczytuje macierz z pliku tekstowego.
 * Zmienna 'plik' musi byc wskaznikiem do pliku tekstowego otworzonego w trybie do odczytu.
 * Pierwsze dwie wczytane z pliku liczby to ilosc wierszy i kolumn, ich wartosci dostepne sa za pomoca wskaznikow 'w' i 'k'.
 * Wartoscia zwracana jest adres dynamicznie utworzonej macierzy posiadajacej 'w' wierszy i 'k' kolumn.  */
float ** wczytaj_z_pliku(FILE *plik,int *w,int* k)
{
	int iw,ik;
	float ** M;
	fscanf(plik,"%d",w);
	fscanf(plik,"%d",k);
	M=utworz_macierz(*w,*k);
	for (iw=0;iw<*w;iw++)
	{
		for (ik=0;ik<*k;ik++)
			fscanf(plik,"%f",*(M+iw)+ik);
	}
	return M;
}
